Index: uspace/lib/ui/private/tabset.h
===================================================================
--- uspace/lib/ui/private/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab set structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_TABSET_H
+#define _UI_PRIVATE_TABSET_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <stdbool.h>
+#include <types/common.h>
+#include <types/ui/tab.h>
+#include <types/ui/tabset.h>
+
+/** Actual structure of tab set.
+ *
+ * This is private to libui.
+ */
+struct ui_tab_set {
+	/** Base control object */
+	struct ui_control *control;
+	/** UI reource */
+	struct ui_resource *res;
+	/** Tab set rectangle */
+	gfx_rect_t rect;
+	/** Selected tab */
+	struct ui_tab *selected;
+	/** List of tabs (ui_tab_t) */
+	list_t tabs;
+};
+
+extern void ui_tab_set_select(ui_tab_set_t *, ui_tab_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/testctl.h
===================================================================
--- uspace/lib/ui/private/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Test control
+ *
+ */
+
+#ifndef _UI_PRIVATE_TESTCTL_H
+#define _UI_PRIVATE_TESTCTL_H
+
+#include <types/ui/testctl.h>
+
+/** Actual structure of test control.
+ *
+ * This is private to libui.
+ */
+struct ui_test_ctl {
+	/** Base control object */
+	struct ui_control *control;
+	/** Test response structure */
+	ui_tc_resp_t *resp;
+};
+
+extern ui_control_ops_t ui_test_ctl_ops;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/ui.h
===================================================================
--- uspace/lib/ui/private/ui.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/ui.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,6 +41,8 @@
 #include <gfx/coord.h>
 #include <display.h>
+#include <fibril_synch.h>
 #include <io/console.h>
 #include <stdbool.h>
+#include <types/common.h>
 
 /** Actual structure of user interface.
@@ -59,8 +61,16 @@
 	/** Output owned by UI, clean up when destroying UI */
 	bool myoutput;
+	/** @c true iff UI is suspended */
+	bool suspended;
 	/** @c true if terminating */
 	bool quit;
 	/** Windows (in stacking order, ui_window_t) */
 	list_t windows;
+	/** UI lock */
+	fibril_mutex_t lock;
+	/** Clickmatic */
+	struct ui_clickmatic *clickmatic;
+	/** Default input device ID used to determine new window's seat */
+	sysarg_t idev_id;
 };
 
Index: uspace/lib/ui/private/wdecor.h
===================================================================
--- uspace/lib/ui/private/wdecor.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/wdecor.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,4 +41,5 @@
 #include <io/pos_event.h>
 #include <stdbool.h>
+#include <types/common.h>
 #include <types/ui/cursor.h>
 #include <types/ui/wdecor.h>
@@ -63,4 +64,12 @@
 	/** Window is active */
 	bool active;
+	/** Window is maximized */
+	bool maximized;
+	/** System menu handle is active */
+	bool sysmenu_hdl_active;
+	/** Minimize button */
+	struct ui_pbutton *btn_min;
+	/** Maximize button */
+	struct ui_pbutton *btn_max;
 	/** Close button */
 	struct ui_pbutton *btn_close;
@@ -76,4 +85,12 @@
 	/** Title bar rectangle */
 	gfx_rect_t title_bar_rect;
+	/** System menu handle rectangle */
+	gfx_rect_t sysmenu_hdl_rect;
+	/** Window caption rectangle */
+	gfx_rect_t caption_rect;
+	/** Minimize button rectangle */
+	gfx_rect_t btn_min_rect;
+	/** Maximize button rectangle */
+	gfx_rect_t btn_max_rect;
 	/** Close button rectangle */
 	gfx_rect_t btn_close_rect;
@@ -82,10 +99,20 @@
 } ui_wdecor_geom_t;
 
+extern void ui_wdecor_sysmenu_open(ui_wdecor_t *, sysarg_t);
+extern void ui_wdecor_sysmenu_left(ui_wdecor_t *, sysarg_t);
+extern void ui_wdecor_sysmenu_right(ui_wdecor_t *, sysarg_t);
+extern void ui_wdecor_sysmenu_accel(ui_wdecor_t *, char32_t, sysarg_t);
+extern void ui_wdecor_minimize(ui_wdecor_t *);
+extern void ui_wdecor_maximize(ui_wdecor_t *);
+extern void ui_wdecor_unmaximize(ui_wdecor_t *);
 extern void ui_wdecor_close(ui_wdecor_t *);
-extern void ui_wdecor_move(ui_wdecor_t *, gfx_coord2_t *);
+extern void ui_wdecor_move(ui_wdecor_t *, gfx_coord2_t *, sysarg_t);
 extern void ui_wdecor_resize(ui_wdecor_t *, ui_wdecor_rsztype_t,
-    gfx_coord2_t *);
+    gfx_coord2_t *, sysarg_t);
 extern void ui_wdecor_set_cursor(ui_wdecor_t *, ui_stock_cursor_t);
 extern void ui_wdecor_get_geom(ui_wdecor_t *, ui_wdecor_geom_t *);
+extern errno_t ui_wdecor_sysmenu_hdl_paint_gfx(ui_wdecor_t *, gfx_rect_t *);
+extern errno_t ui_wdecor_sysmenu_hdl_paint_text(ui_wdecor_t *, gfx_rect_t *);
+extern errno_t ui_wdecor_sysmenu_hdl_paint(ui_wdecor_t *, gfx_rect_t *);
 extern void ui_wdecor_frame_pos_event(ui_wdecor_t *, pos_event_t *);
 extern ui_wdecor_rsztype_t ui_wdecor_get_rsztype(ui_wdecor_t *,
Index: uspace/lib/ui/private/window.h
===================================================================
--- uspace/lib/ui/private/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/window.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,4 +47,5 @@
 #include <memgfx/memgc.h>
 #include <memgfx/xlategc.h>
+#include <types/common.h>
 #include <types/ui/cursor.h>
 #include <types/ui/window.h>
@@ -77,4 +78,6 @@
 	/** Window rectangle */
 	gfx_rect_t rect;
+	/** Normal window rectangle (when not maximized) */
+	gfx_rect_t normal_rect;
 	/** Display position (if fullscreen mode) */
 	gfx_coord2_t dpos;
@@ -91,17 +94,45 @@
 	/** Window decoration */
 	struct ui_wdecor *wdecor;
+	/** System menu */
+	struct ui_menu *sysmenu;
+	/** System menu restore entry */
+	struct ui_menu_entry *sysmenu_restore;
+	/** System menu minimize entry */
+	struct ui_menu_entry *sysmenu_minimize;
+	/** System menu maximize entry */
+	struct ui_menu_entry *sysmenu_maximize;
+	/** Menu bar */
+	struct ui_menu_bar *mbar;
 	/** Top-level control in the application area */
 	struct ui_control *control;
 	/** Current cursor */
 	ui_stock_cursor_t cursor;
+	/** Window placement */
+	ui_wnd_placement_t placement;
 };
 
+/** Size change operation */
+typedef enum {
+	/** Resize window */
+	ui_wsc_resize,
+	/** Maximize window */
+	ui_wsc_maximize,
+	/** Unmaximize window */
+	ui_wsc_unmaximize
+} ui_wnd_sc_op_t;
+
 extern display_stock_cursor_t wnd_dcursor_from_cursor(ui_stock_cursor_t);
+extern void ui_window_send_sysmenu(ui_window_t *, sysarg_t);
+extern void ui_window_send_minimize(ui_window_t *);
+extern void ui_window_send_maximize(ui_window_t *);
+extern void ui_window_send_unmaximize(ui_window_t *);
 extern void ui_window_send_close(ui_window_t *);
-extern void ui_window_send_focus(ui_window_t *);
+extern void ui_window_send_focus(ui_window_t *, unsigned);
 extern void ui_window_send_kbd(ui_window_t *, kbd_event_t *);
 extern errno_t ui_window_send_paint(ui_window_t *);
 extern void ui_window_send_pos(ui_window_t *, pos_event_t *);
-extern void ui_window_send_unfocus(ui_window_t *);
+extern void ui_window_send_unfocus(ui_window_t *, unsigned);
+extern errno_t ui_window_size_change(ui_window_t *, gfx_rect_t *,
+    ui_wnd_sc_op_t);
 
 #endif
Index: uspace/lib/ui/src/accel.c
===================================================================
--- uspace/lib/ui/src/accel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/src/accel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,133 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Accelerator processing
+ */
+
+#include <ctype.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/accel.h>
+
+/** Process text with accelerator markup.
+ *
+ * Parse text with tilde markup into a list of strings. @a *rbuf is set
+ * to point to a newly allocated buffer containing consecutive null-terminated
+ * strings.
+ *
+ * Each part between two '~' becomes one string. '~~' is translated into
+ * a literal '~' character. @a *endptr is set to point to the first character
+ * beyond the end of the list.
+ *
+ * @param str String with tilde markup
+ * @param rbuf Place to store pointer to newly allocated buffer.
+ * @param endptr Place to store end pointer (just after last character)
+ * @return EOK on success or an error code
+ */
+errno_t ui_accel_process(const char *str, char **rbuf, char **endptr)
+{
+	const char *sp;
+	char *dp;
+	char *buf;
+
+	buf = malloc(str_size(str) + 1);
+	if (buf == NULL)
+		return ENOMEM;
+
+	/* Break down string into list of (non)highlighted parts */
+	sp = str;
+	dp = buf;
+	while (*sp != '\0') {
+		if (*sp == '~') {
+			if (sp[1] == '~') {
+				sp += 2;
+				*dp++ = '~';
+			} else {
+				++sp;
+				*dp++ = '\0';
+			}
+		} else {
+			*dp++ = *sp++;
+		}
+	}
+
+	*dp++ = '\0';
+	*rbuf = buf;
+	*endptr = dp;
+
+	return EOK;
+}
+
+/** Get accelerator character from marked-up string.
+ *
+ * @param str String with '~' accelerator markup
+ *
+ * @return Accelerator character (lowercase) or the null character if
+ *         the menu has no accelerator.
+ */
+char32_t ui_accel_get(const char *str)
+{
+	const char *sp = str;
+	size_t off;
+
+	while (*sp != '\0') {
+		if (*sp == '~') {
+			if (sp[1] == '~') {
+				++sp;
+			} else {
+				/* Found the accelerator */
+				++sp;
+				break;
+			}
+		}
+
+		++sp;
+	}
+
+	if (*sp == '\0') {
+		/* No accelerator */
+		return '\0';
+	}
+
+	/* Decode accelerator character */
+	off = 0;
+
+	/*
+	 * NOTE: tolower is unlike to actually convert to lowercase
+	 * in case of non-ASCII characters
+	 */
+	return tolower(str_decode(sp, &off, STR_NO_LIMIT));
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/checkbox.c
===================================================================
--- uspace/lib/ui/src/checkbox.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/checkbox.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -52,4 +52,7 @@
 	checkbox_box_h = 16,
 	checkbox_label_margin = 8,
+	checkbox_cross_n = 5,
+	checkbox_cross_w = 2,
+	checkbox_cross_h = 2
 };
 
@@ -136,12 +139,32 @@
 }
 
-/** Set button rectangle.
- *
- * @param checkbox Button
- * @param rect New button rectangle
+/** Set check box rectangle.
+ *
+ * @param checkbox Check box
+ * @param rect New check box rectangle
  */
 void ui_checkbox_set_rect(ui_checkbox_t *checkbox, gfx_rect_t *rect)
 {
 	checkbox->rect = *rect;
+}
+
+/** Return if check box is checked.
+ *
+ * @param checkbox Check box
+ * @return @c true iff check box is checked
+ */
+bool ui_checkbox_get_checked(ui_checkbox_t *checkbox)
+{
+	return checkbox->checked;
+}
+
+/** Set check box checked state.
+ *
+ * @param checkbox Check box
+ * @param checked @c true iff checkbox should be checked
+ */
+void ui_checkbox_set_checked(ui_checkbox_t *checkbox, bool checked)
+{
+	checkbox->checked = checked;
 }
 
@@ -188,15 +211,16 @@
 
 	if (checkbox->checked) {
-		box_center.x = (box_inside.p0.x + box_inside.p1.x) / 2;
-		box_center.y = (box_inside.p0.y + box_inside.p1.y) / 2;
-
-		gfx_text_fmt_init(&fmt);
-		fmt.color = checkbox->res->entry_fg_color;
-		fmt.halign = gfx_halign_center;
-		fmt.valign = gfx_valign_center;
-
-		rc = gfx_puttext(checkbox->res->font, &box_center, &fmt, "X");
+		rc = gfx_set_color(checkbox->res->gc,
+		    checkbox->res->entry_fg_color);
 		if (rc != EOK)
 			goto error;
+
+		box_center.x = (box_inside.p0.x + box_inside.p1.x) / 2 - 1;
+		box_center.y = (box_inside.p0.y + box_inside.p1.y) / 2 - 1;
+
+		rc = ui_paint_cross(checkbox->res->gc, &box_center,
+		    checkbox_cross_n, checkbox_cross_w, checkbox_cross_h);
+		if (rc != EOK)
+			goto error;
 	}
 
@@ -207,9 +231,10 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = checkbox->res->font;
 	fmt.color = checkbox->res->wnd_text_color;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_center;
 
-	rc = gfx_puttext(checkbox->res->font, &pos, &fmt, checkbox->caption);
+	rc = gfx_puttext(&pos, &fmt, checkbox->caption);
 	if (rc != EOK)
 		goto error;
@@ -244,4 +269,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = checkbox->res->font;
 	fmt.color = depressed ? checkbox->res->entry_act_bg_color :
 	    checkbox->res->wnd_text_color;
@@ -249,6 +275,5 @@
 	fmt.valign = gfx_valign_top;
 
-	rc = gfx_puttext(checkbox->res->font, &pos, &fmt,
-	    checkbox->checked ? "[X]" : "[ ]");
+	rc = gfx_puttext(&pos, &fmt, checkbox->checked ? "[X]" : "[ ]");
 	if (rc != EOK)
 		goto error;
@@ -259,5 +284,5 @@
 	fmt.color = checkbox->res->wnd_text_color;
 
-	rc = gfx_puttext(checkbox->res->font, &pos, &fmt, checkbox->caption);
+	rc = gfx_puttext(&pos, &fmt, checkbox->caption);
 	if (rc != EOK)
 		goto error;
@@ -397,4 +422,6 @@
 		}
 		break;
+	case POS_DCLICK:
+		break;
 	}
 
Index: uspace/lib/ui/src/clickmatic.c
===================================================================
--- uspace/lib/ui/src/clickmatic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/src/clickmatic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,163 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Clickmatic.
+ *
+ * Clickmatic is used to periodically generate events in particular cases
+ * when a mouse button is held down, such as when holding the button or
+ * trough of a scrollbar.
+ */
+
+#include <fibril_synch.h>
+#include <stdlib.h>
+#include <ui/clickmatic.h>
+#include <ui/ui.h>
+#include "../private/clickmatic.h"
+
+enum {
+	/** Initial clickmatic delay in MS */
+	clickmatic_delay_ms = 500,
+	/** Clickmatic repeat rate in clicks per second */
+	clickmatic_rate = 10
+};
+
+static void ui_clickmatic_timer_fun(void *);
+
+/** Create clickmatic.
+ *
+ * @param ui UI
+ * @param rclickmatic Place to store pointer to new clickmatic
+ * @return EOK on success or an error code
+ */
+errno_t ui_clickmatic_create(ui_t *ui, ui_clickmatic_t **rclickmatic)
+{
+	ui_clickmatic_t *clickmatic;
+
+	clickmatic = calloc(1, sizeof(ui_clickmatic_t));
+	if (clickmatic == NULL)
+		return ENOMEM;
+
+	clickmatic->ui = ui;
+	clickmatic->timer = fibril_timer_create(NULL);
+	if (clickmatic->timer == NULL) {
+		free(clickmatic);
+		return ENOMEM;
+	}
+
+	*rclickmatic = clickmatic;
+	return EOK;
+}
+
+/** Set clickmatick callbacks.
+ *
+ * @param clickmatic Clickmatic
+ * @param cb Callbacks
+ * @param arg Argument to callbacks
+ */
+void ui_clickmatic_set_cb(ui_clickmatic_t *clickmatic, ui_clickmatic_cb_t *cb,
+    void *arg)
+{
+	clickmatic->cb = cb;
+	clickmatic->arg = arg;
+}
+
+/** Destroy clickmatic.
+ *
+ * @param clickmatic Clickmatic or @c NULL
+ */
+void ui_clickmatic_destroy(ui_clickmatic_t *clickmatic)
+{
+	if (clickmatic == NULL)
+		return;
+
+	fibril_timer_destroy(clickmatic->timer);
+	free(clickmatic);
+}
+
+/** Activate clickmatic.
+ *
+ * This generates one click event, then starts repeating after delay.
+ *
+ * @param clickmatic Clickmatic
+ */
+void ui_clickmatic_press(ui_clickmatic_t *clickmatic)
+{
+	ui_clickmatic_clicked(clickmatic);
+
+	fibril_timer_set(clickmatic->timer, 1000 * clickmatic_delay_ms,
+	    ui_clickmatic_timer_fun, (void *)clickmatic);
+}
+
+/** Deactivate clickmatic.
+ *
+ * Stops generating events.
+ *
+ * @param clickmatic Clickmatic
+ */
+void ui_clickmatic_release(ui_clickmatic_t *clickmatic)
+{
+	(void) fibril_timer_clear(clickmatic->timer);
+}
+
+/** Clickmatic clicked event.
+ *
+ * @param clickmatic Clickmatic
+ */
+void ui_clickmatic_clicked(ui_clickmatic_t *clickmatic)
+{
+	if (clickmatic->cb != NULL && clickmatic->cb->clicked != NULL)
+		clickmatic->cb->clicked(clickmatic, clickmatic->arg);
+}
+
+/** Clickmatic timer function.
+ *
+ * @param arg Argument (ui_clickmatic_t *)
+ */
+static void ui_clickmatic_timer_fun(void *arg)
+{
+	ui_clickmatic_t *clickmatic = (ui_clickmatic_t *)arg;
+
+	/*
+	 * Because we are operating in a different fibril, we must lock
+	 * the UI to ensure mutual exclusion with normal UI events
+	 */
+
+	ui_lock(clickmatic->ui);
+	ui_clickmatic_clicked(clickmatic);
+	ui_unlock(clickmatic->ui);
+
+	fibril_timer_set(clickmatic->timer, 1000000 / clickmatic_rate,
+	    ui_clickmatic_timer_fun, (void *)clickmatic);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/control.c
===================================================================
--- uspace/lib/ui/src/control.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/control.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -130,9 +130,10 @@
  *
  * @param control Control
+ * @param nfocus Number of remaining foci
  */
-void ui_control_unfocus(ui_control_t *control)
+void ui_control_unfocus(ui_control_t *control, unsigned nfocus)
 {
 	if (control->ops->unfocus != NULL)
-		control->ops->unfocus(control->ext);
+		control->ops->unfocus(control->ext, nfocus);
 }
 
Index: uspace/lib/ui/src/entry.c
===================================================================
--- uspace/lib/ui/src/entry.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/entry.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -314,4 +314,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = res->font;
 	fmt.color = res->entry_fg_color;
 	fmt.halign = gfx_halign_left;
@@ -329,5 +330,5 @@
 	entry->text[off1] = '\0';
 
-	rc = gfx_puttext(res->font, &pos, &fmt, entry->text);
+	rc = gfx_puttext(&pos, &fmt, entry->text);
 	if (rc != EOK) {
 		(void) gfx_set_clip_rect(res->gc, NULL);
@@ -335,5 +336,5 @@
 	}
 
-	gfx_text_cont(res->font, &pos, &fmt, entry->text, &cpos, &cfmt);
+	gfx_text_cont(&pos, &fmt, entry->text, &cpos, &cfmt);
 	entry->text[off1] = c;
 
@@ -345,5 +346,5 @@
 		cfmt.color = res->entry_sel_text_fg_color;
 
-		gfx_text_rect(res->font, &cpos, &cfmt, entry->text + off1, &sel);
+		gfx_text_rect(&cpos, &cfmt, entry->text + off1, &sel);
 		sel.p0.x -= ui_entry_sel_hpad;
 		sel.p0.y -= ui_entry_sel_vpad;
@@ -359,5 +360,5 @@
 			goto error;
 
-		rc = gfx_puttext(res->font, &cpos, &cfmt, entry->text + off1);
+		rc = gfx_puttext(&cpos, &cfmt, entry->text + off1);
 		if (rc != EOK) {
 			(void) gfx_set_clip_rect(res->gc, NULL);
@@ -365,6 +366,5 @@
 		}
 
-		gfx_text_cont(res->font, &cpos, &cfmt, entry->text + off1,
-		    &cpos, &cfmt);
+		gfx_text_cont(&cpos, &cfmt, entry->text + off1, &cpos, &cfmt);
 
 		entry->text[off2] = c;
@@ -374,5 +374,5 @@
 	cfmt.color = res->entry_fg_color;
 
-	rc = gfx_puttext(res->font, &cpos, &cfmt, entry->text + off2);
+	rc = gfx_puttext(&cpos, &cfmt, entry->text + off2);
 	if (rc != EOK) {
 		(void) gfx_set_clip_rect(res->gc, NULL);
@@ -421,9 +421,9 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = res->font;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_top;
 
-	return gfx_text_find_pos(res->font, &geom.text_pos, &fmt,
-	    entry->text, fpos);
+	return gfx_text_find_pos(&geom.text_pos, &fmt, entry->text, fpos);
 }
 
@@ -664,5 +664,4 @@
 		break;
 	}
-
 	return ui_claimed;
 }
@@ -743,13 +742,4 @@
 	if (!entry->active)
 		return ui_unclaimed;
-
-	if (event->type == KEY_PRESS && event->c >= ' ') {
-		off = 0;
-		rc = chr_encode(event->c, buf, &off, sizeof(buf));
-		if (rc == EOK) {
-			buf[off] = '\0';
-			(void) ui_entry_insert_str(entry, buf);
-		}
-	}
 
 	/*
@@ -768,4 +758,14 @@
 	if (event->type == KEY_RELEASE && event->key == KC_RSHIFT)
 		entry->rshift_held = false;
+
+	if (event->type == KEY_PRESS &&
+	    (event->mods & (KM_CTRL | KM_ALT)) == 0 && event->c >= ' ') {
+		off = 0;
+		rc = chr_encode(event->c, buf, &off, sizeof(buf));
+		if (rc == EOK) {
+			buf[off] = '\0';
+			(void) ui_entry_insert_str(entry, buf);
+		}
+	}
 
 	if (event->type == KEY_PRESS &&
@@ -1111,7 +1111,7 @@
 		anchor.y = 0;
 		gfx_text_fmt_init(&fmt);
+		fmt.font = res->font;
 		fmt.halign = entry->halign;
-		gfx_text_start_pos(res->font, &anchor, &fmt, entry->text,
-		    &tpos);
+		gfx_text_start_pos(&anchor, &fmt, entry->text, &tpos);
 		entry->scroll_pos = tpos.x - geom.text_rect.p0.x;
 	} else if (geom.text_pos.x + width < geom.text_rect.p1.x &&
Index: uspace/lib/ui/src/filedialog.c
===================================================================
--- uspace/lib/ui/src/filedialog.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/filedialog.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,4 +41,5 @@
 #include <ui/label.h>
 #include <ui/filedialog.h>
+#include <ui/filelist.h>
 #include <ui/pbutton.h>
 #include <ui/resource.h>
@@ -53,4 +54,13 @@
 	.close = ui_file_dialog_wnd_close,
 	.kbd = ui_file_dialog_wnd_kbd
+};
+
+static void ui_file_dialog_flist_activate_req(ui_file_list_t *, void *);
+static void ui_file_dialog_flist_selected(ui_file_list_t *, void *,
+    const char *);
+
+ui_file_list_cb_t ui_file_dialog_flist_cb = {
+	.activate_req = ui_file_dialog_flist_activate_req,
+	.selected = ui_file_dialog_flist_selected
 };
 
@@ -96,4 +106,5 @@
 	ui_label_t *label = NULL;
 	ui_entry_t *entry = NULL;
+	ui_file_list_t *flist = NULL;
 	ui_pbutton_t *bok = NULL;
 	ui_pbutton_t *bcancel = NULL;
@@ -115,10 +126,10 @@
 		wparams.rect.p0.y = 0;
 		wparams.rect.p1.x = 40;
-		wparams.rect.p1.y = 9;
+		wparams.rect.p1.y = 20;
 	} else {
 		wparams.rect.p0.x = 0;
 		wparams.rect.p0.y = 0;
 		wparams.rect.p1.x = 300;
-		wparams.rect.p1.y = 135;
+		wparams.rect.p1.y = 335;
 	}
 
@@ -167,7 +178,7 @@
 	if (ui_is_textmode(ui)) {
 		rect.p0.x = 3;
-		rect.p0.y = 4;
+		rect.p0.y = 3;
 		rect.p1.x = 37;
-		rect.p1.y = 5;
+		rect.p1.y = 4;
 	} else {
 		rect.p0.x = 10;
@@ -192,4 +203,65 @@
 	entry = NULL;
 
+	/* Files label */
+	rc = ui_label_create(ui_res, "Files:", &label);
+	if (rc != EOK)
+		goto error;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 3;
+		rect.p0.y = 5;
+		rect.p1.x = 17;
+		rect.p1.y = 6;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 90;
+		rect.p1.x = 190;
+		rect.p1.y = 105;
+	}
+
+	ui_label_set_rect(label, &rect);
+
+	rc = ui_fixed_add(fixed, ui_label_ctl(label));
+	if (rc != EOK)
+		goto error;
+
+	label = NULL;
+
+	/* File list */
+
+	rc = ui_file_list_create(window, false, &flist);
+	if (rc != EOK)
+		goto error;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 3;
+		rect.p0.y = 6;
+		rect.p1.x = 37;
+		rect.p1.y = 16;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 110;
+		rect.p1.x = 290;
+		rect.p1.y = 280;
+	}
+
+	ui_file_list_set_rect(flist, &rect);
+	ui_file_list_set_cb(flist, &ui_file_dialog_flist_cb, dialog);
+
+	rc = ui_fixed_add(fixed, ui_file_list_ctl(flist));
+	if (rc != EOK)
+		goto error;
+
+	dialog->flist = flist;
+	flist = NULL;
+
+	rc = ui_file_list_read_dir(dialog->flist, ".");
+	if (rc != EOK)
+		goto error;
+
+	/* OK button */
+
 	rc = ui_pbutton_create(ui_res, "OK", &bok);
 	if (rc != EOK)
@@ -201,12 +273,12 @@
 	if (ui_is_textmode(ui)) {
 		rect.p0.x = 10;
-		rect.p0.y = 6;
+		rect.p0.y = 17;
 		rect.p1.x = 20;
-		rect.p1.y = 7;
+		rect.p1.y = 18;
 	} else {
 		rect.p0.x = 55;
-		rect.p0.y = 90;
+		rect.p0.y = 290;
 		rect.p1.x = 145;
-		rect.p1.y = 118;
+		rect.p1.y = 318;
 	}
 
@@ -222,4 +294,6 @@
 	bok = NULL;
 
+	/* Cancel button */
+
 	rc = ui_pbutton_create(ui_res, "Cancel", &bcancel);
 	if (rc != EOK)
@@ -231,12 +305,12 @@
 	if (ui_is_textmode(ui)) {
 		rect.p0.x = 22;
-		rect.p0.y = 6;
+		rect.p0.y = 17;
 		rect.p1.x = 32;
-		rect.p1.y = 7;
+		rect.p1.y = 18;
 	} else {
 		rect.p0.x = 155;
-		rect.p0.y = 90;
+		rect.p0.y = 290;
 		rect.p1.x = 245;
-		rect.p1.y = 118;
+		rect.p1.y = 318;
 	}
 
@@ -263,4 +337,6 @@
 	if (entry != NULL)
 		ui_entry_destroy(entry);
+	if (flist != NULL)
+		ui_file_list_destroy(flist);
 	if (bok != NULL)
 		ui_pbutton_destroy(bok);
@@ -328,4 +404,9 @@
 	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
 	const char *fname;
+	ui_evclaim_t claim;
+
+	claim = ui_window_def_kbd(window, event);
+	if (claim == ui_claimed)
+		return;
 
 	if (event->type == KEY_PRESS &&
@@ -347,5 +428,20 @@
 	}
 
-	ui_window_def_kbd(window, event);
+}
+
+static void ui_file_dialog_flist_activate_req(ui_file_list_t *flist, void *arg)
+{
+	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
+
+	ui_file_list_activate(dialog->flist);
+	ui_entry_deactivate(dialog->ename);
+}
+
+static void ui_file_dialog_flist_selected(ui_file_list_t *flist, void *arg,
+    const char *fname)
+{
+	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
+
+	dialog->cb->bok(dialog, dialog->arg, fname);
 }
 
